// Generated by gencpp from file ld_msgs/ld_mobileye_lane.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_MOBILEYE_LANE_H
#define LD_MSGS_MESSAGE_LD_MOBILEYE_LANE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_mobileye_lane_
{
  typedef ld_mobileye_lane_<ContainerAllocator> Type;

  ld_mobileye_lane_()
    : header()
    , type()
    , distance_to_left_lane(0.0)
    , distance_to_right_lane(0.0)
    , number_of_next_lane(0)
    , address()
    , ID(0)
    , left_c0(0.0)
    , left_c2(0.0)
    , left_c3(0.0)
    , left_width_marking(0.0)
    , left_model_degree(0)
    , left_quality(0)
    , left_lane_type(0)
    , left_c1(0.0)
    , right_c0(0.0)
    , right_c2(0.0)
    , right_c3(0.0)
    , right_width_marking(0.0)
    , right_model_degree(0)
    , right_quality(0)
    , right_lane_type(0)
    , right_c1(0.0)
    , next_1_left_c0(0.0)
    , next_1_left_c2(0.0)
    , next_1_left_c3(0.0)
    , next_1_left_width_marking(0.0)
    , next_1_left_model_degree(0)
    , next_1_left_quality(0)
    , next_1_left_lane_type(0)
    , next_1_left_c1(0.0)
    , next_1_right_c0(0.0)
    , next_1_right_c2(0.0)
    , next_1_right_c3(0.0)
    , next_1_right_width_marking(0.0)
    , next_1_right_model_degree(0)
    , next_1_right_quality(0)
    , next_1_right_lane_type(0)
    , next_1_right_c1(0.0)
    , next_2_left_c0(0.0)
    , next_2_left_c2(0.0)
    , next_2_left_c3(0.0)
    , next_2_left_width_marking(0.0)
    , next_2_left_model_degree(0)
    , next_2_left_quality(0)
    , next_2_left_lane_type(0)
    , next_2_left_c1(0.0)
    , next_2_right_c0(0.0)
    , next_2_right_c2(0.0)
    , next_2_right_c3(0.0)
    , next_2_right_width_marking(0.0)
    , next_2_right_model_degree(0)
    , next_2_right_quality(0)
    , next_2_right_lane_type(0)
    , next_2_right_c1(0.0)
    , next_3_left_c0(0.0)
    , next_3_left_c2(0.0)
    , next_3_left_c3(0.0)
    , next_3_left_width_marking(0.0)
    , next_3_left_model_degree(0)
    , next_3_left_quality(0)
    , next_3_left_lane_type(0)
    , next_3_left_c1(0.0)
    , next_3_right_c0(0.0)
    , next_3_right_c2(0.0)
    , next_3_right_c3(0.0)
    , next_3_right_width_marking(0.0)
    , next_3_right_model_degree(0)
    , next_3_right_quality(0)
    , next_3_right_lane_type(0)
    , next_3_right_c1(0.0)
    , next_4_left_c0(0.0)
    , next_4_left_c2(0.0)
    , next_4_left_c3(0.0)
    , next_4_left_width_marking(0.0)
    , next_4_left_model_degree(0)
    , next_4_left_quality(0)
    , next_4_left_lane_type(0)
    , next_4_left_c1(0.0)
    , next_4_right_c0(0.0)
    , next_4_right_c2(0.0)
    , next_4_right_c3(0.0)
    , next_4_right_width_marking(0.0)
    , next_4_right_model_degree(0)
    , next_4_right_quality(0)
    , next_4_right_lane_type(0)
    , next_4_right_c1(0.0)  {
    }
  ld_mobileye_lane_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , type(_alloc)
    , distance_to_left_lane(0.0)
    , distance_to_right_lane(0.0)
    , number_of_next_lane(0)
    , address(_alloc)
    , ID(0)
    , left_c0(0.0)
    , left_c2(0.0)
    , left_c3(0.0)
    , left_width_marking(0.0)
    , left_model_degree(0)
    , left_quality(0)
    , left_lane_type(0)
    , left_c1(0.0)
    , right_c0(0.0)
    , right_c2(0.0)
    , right_c3(0.0)
    , right_width_marking(0.0)
    , right_model_degree(0)
    , right_quality(0)
    , right_lane_type(0)
    , right_c1(0.0)
    , next_1_left_c0(0.0)
    , next_1_left_c2(0.0)
    , next_1_left_c3(0.0)
    , next_1_left_width_marking(0.0)
    , next_1_left_model_degree(0)
    , next_1_left_quality(0)
    , next_1_left_lane_type(0)
    , next_1_left_c1(0.0)
    , next_1_right_c0(0.0)
    , next_1_right_c2(0.0)
    , next_1_right_c3(0.0)
    , next_1_right_width_marking(0.0)
    , next_1_right_model_degree(0)
    , next_1_right_quality(0)
    , next_1_right_lane_type(0)
    , next_1_right_c1(0.0)
    , next_2_left_c0(0.0)
    , next_2_left_c2(0.0)
    , next_2_left_c3(0.0)
    , next_2_left_width_marking(0.0)
    , next_2_left_model_degree(0)
    , next_2_left_quality(0)
    , next_2_left_lane_type(0)
    , next_2_left_c1(0.0)
    , next_2_right_c0(0.0)
    , next_2_right_c2(0.0)
    , next_2_right_c3(0.0)
    , next_2_right_width_marking(0.0)
    , next_2_right_model_degree(0)
    , next_2_right_quality(0)
    , next_2_right_lane_type(0)
    , next_2_right_c1(0.0)
    , next_3_left_c0(0.0)
    , next_3_left_c2(0.0)
    , next_3_left_c3(0.0)
    , next_3_left_width_marking(0.0)
    , next_3_left_model_degree(0)
    , next_3_left_quality(0)
    , next_3_left_lane_type(0)
    , next_3_left_c1(0.0)
    , next_3_right_c0(0.0)
    , next_3_right_c2(0.0)
    , next_3_right_c3(0.0)
    , next_3_right_width_marking(0.0)
    , next_3_right_model_degree(0)
    , next_3_right_quality(0)
    , next_3_right_lane_type(0)
    , next_3_right_c1(0.0)
    , next_4_left_c0(0.0)
    , next_4_left_c2(0.0)
    , next_4_left_c3(0.0)
    , next_4_left_width_marking(0.0)
    , next_4_left_model_degree(0)
    , next_4_left_quality(0)
    , next_4_left_lane_type(0)
    , next_4_left_c1(0.0)
    , next_4_right_c0(0.0)
    , next_4_right_c2(0.0)
    , next_4_right_c3(0.0)
    , next_4_right_width_marking(0.0)
    , next_4_right_model_degree(0)
    , next_4_right_quality(0)
    , next_4_right_lane_type(0)
    , next_4_right_c1(0.0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _type_type;
  _type_type type;

   typedef double _distance_to_left_lane_type;
  _distance_to_left_lane_type distance_to_left_lane;

   typedef double _distance_to_right_lane_type;
  _distance_to_right_lane_type distance_to_right_lane;

   typedef uint8_t _number_of_next_lane_type;
  _number_of_next_lane_type number_of_next_lane;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _address_type;
  _address_type address;

   typedef uint8_t _ID_type;
  _ID_type ID;

   typedef double _left_c0_type;
  _left_c0_type left_c0;

   typedef double _left_c2_type;
  _left_c2_type left_c2;

   typedef double _left_c3_type;
  _left_c3_type left_c3;

   typedef double _left_width_marking_type;
  _left_width_marking_type left_width_marking;

   typedef uint8_t _left_model_degree_type;
  _left_model_degree_type left_model_degree;

   typedef uint8_t _left_quality_type;
  _left_quality_type left_quality;

   typedef uint8_t _left_lane_type_type;
  _left_lane_type_type left_lane_type;

   typedef double _left_c1_type;
  _left_c1_type left_c1;

   typedef double _right_c0_type;
  _right_c0_type right_c0;

   typedef double _right_c2_type;
  _right_c2_type right_c2;

   typedef double _right_c3_type;
  _right_c3_type right_c3;

   typedef double _right_width_marking_type;
  _right_width_marking_type right_width_marking;

   typedef uint8_t _right_model_degree_type;
  _right_model_degree_type right_model_degree;

   typedef uint8_t _right_quality_type;
  _right_quality_type right_quality;

   typedef uint8_t _right_lane_type_type;
  _right_lane_type_type right_lane_type;

   typedef double _right_c1_type;
  _right_c1_type right_c1;

   typedef double _next_1_left_c0_type;
  _next_1_left_c0_type next_1_left_c0;

   typedef double _next_1_left_c2_type;
  _next_1_left_c2_type next_1_left_c2;

   typedef double _next_1_left_c3_type;
  _next_1_left_c3_type next_1_left_c3;

   typedef double _next_1_left_width_marking_type;
  _next_1_left_width_marking_type next_1_left_width_marking;

   typedef uint8_t _next_1_left_model_degree_type;
  _next_1_left_model_degree_type next_1_left_model_degree;

   typedef uint8_t _next_1_left_quality_type;
  _next_1_left_quality_type next_1_left_quality;

   typedef uint8_t _next_1_left_lane_type_type;
  _next_1_left_lane_type_type next_1_left_lane_type;

   typedef double _next_1_left_c1_type;
  _next_1_left_c1_type next_1_left_c1;

   typedef double _next_1_right_c0_type;
  _next_1_right_c0_type next_1_right_c0;

   typedef double _next_1_right_c2_type;
  _next_1_right_c2_type next_1_right_c2;

   typedef double _next_1_right_c3_type;
  _next_1_right_c3_type next_1_right_c3;

   typedef double _next_1_right_width_marking_type;
  _next_1_right_width_marking_type next_1_right_width_marking;

   typedef uint8_t _next_1_right_model_degree_type;
  _next_1_right_model_degree_type next_1_right_model_degree;

   typedef uint8_t _next_1_right_quality_type;
  _next_1_right_quality_type next_1_right_quality;

   typedef uint8_t _next_1_right_lane_type_type;
  _next_1_right_lane_type_type next_1_right_lane_type;

   typedef double _next_1_right_c1_type;
  _next_1_right_c1_type next_1_right_c1;

   typedef double _next_2_left_c0_type;
  _next_2_left_c0_type next_2_left_c0;

   typedef double _next_2_left_c2_type;
  _next_2_left_c2_type next_2_left_c2;

   typedef double _next_2_left_c3_type;
  _next_2_left_c3_type next_2_left_c3;

   typedef double _next_2_left_width_marking_type;
  _next_2_left_width_marking_type next_2_left_width_marking;

   typedef uint8_t _next_2_left_model_degree_type;
  _next_2_left_model_degree_type next_2_left_model_degree;

   typedef uint8_t _next_2_left_quality_type;
  _next_2_left_quality_type next_2_left_quality;

   typedef uint8_t _next_2_left_lane_type_type;
  _next_2_left_lane_type_type next_2_left_lane_type;

   typedef double _next_2_left_c1_type;
  _next_2_left_c1_type next_2_left_c1;

   typedef double _next_2_right_c0_type;
  _next_2_right_c0_type next_2_right_c0;

   typedef double _next_2_right_c2_type;
  _next_2_right_c2_type next_2_right_c2;

   typedef double _next_2_right_c3_type;
  _next_2_right_c3_type next_2_right_c3;

   typedef double _next_2_right_width_marking_type;
  _next_2_right_width_marking_type next_2_right_width_marking;

   typedef uint8_t _next_2_right_model_degree_type;
  _next_2_right_model_degree_type next_2_right_model_degree;

   typedef uint8_t _next_2_right_quality_type;
  _next_2_right_quality_type next_2_right_quality;

   typedef uint8_t _next_2_right_lane_type_type;
  _next_2_right_lane_type_type next_2_right_lane_type;

   typedef double _next_2_right_c1_type;
  _next_2_right_c1_type next_2_right_c1;

   typedef double _next_3_left_c0_type;
  _next_3_left_c0_type next_3_left_c0;

   typedef double _next_3_left_c2_type;
  _next_3_left_c2_type next_3_left_c2;

   typedef double _next_3_left_c3_type;
  _next_3_left_c3_type next_3_left_c3;

   typedef double _next_3_left_width_marking_type;
  _next_3_left_width_marking_type next_3_left_width_marking;

   typedef uint8_t _next_3_left_model_degree_type;
  _next_3_left_model_degree_type next_3_left_model_degree;

   typedef uint8_t _next_3_left_quality_type;
  _next_3_left_quality_type next_3_left_quality;

   typedef uint8_t _next_3_left_lane_type_type;
  _next_3_left_lane_type_type next_3_left_lane_type;

   typedef double _next_3_left_c1_type;
  _next_3_left_c1_type next_3_left_c1;

   typedef double _next_3_right_c0_type;
  _next_3_right_c0_type next_3_right_c0;

   typedef double _next_3_right_c2_type;
  _next_3_right_c2_type next_3_right_c2;

   typedef double _next_3_right_c3_type;
  _next_3_right_c3_type next_3_right_c3;

   typedef double _next_3_right_width_marking_type;
  _next_3_right_width_marking_type next_3_right_width_marking;

   typedef uint8_t _next_3_right_model_degree_type;
  _next_3_right_model_degree_type next_3_right_model_degree;

   typedef uint8_t _next_3_right_quality_type;
  _next_3_right_quality_type next_3_right_quality;

   typedef uint8_t _next_3_right_lane_type_type;
  _next_3_right_lane_type_type next_3_right_lane_type;

   typedef double _next_3_right_c1_type;
  _next_3_right_c1_type next_3_right_c1;

   typedef double _next_4_left_c0_type;
  _next_4_left_c0_type next_4_left_c0;

   typedef double _next_4_left_c2_type;
  _next_4_left_c2_type next_4_left_c2;

   typedef double _next_4_left_c3_type;
  _next_4_left_c3_type next_4_left_c3;

   typedef double _next_4_left_width_marking_type;
  _next_4_left_width_marking_type next_4_left_width_marking;

   typedef uint8_t _next_4_left_model_degree_type;
  _next_4_left_model_degree_type next_4_left_model_degree;

   typedef uint8_t _next_4_left_quality_type;
  _next_4_left_quality_type next_4_left_quality;

   typedef uint8_t _next_4_left_lane_type_type;
  _next_4_left_lane_type_type next_4_left_lane_type;

   typedef double _next_4_left_c1_type;
  _next_4_left_c1_type next_4_left_c1;

   typedef double _next_4_right_c0_type;
  _next_4_right_c0_type next_4_right_c0;

   typedef double _next_4_right_c2_type;
  _next_4_right_c2_type next_4_right_c2;

   typedef double _next_4_right_c3_type;
  _next_4_right_c3_type next_4_right_c3;

   typedef double _next_4_right_width_marking_type;
  _next_4_right_width_marking_type next_4_right_width_marking;

   typedef uint8_t _next_4_right_model_degree_type;
  _next_4_right_model_degree_type next_4_right_model_degree;

   typedef uint8_t _next_4_right_quality_type;
  _next_4_right_quality_type next_4_right_quality;

   typedef uint8_t _next_4_right_lane_type_type;
  _next_4_right_lane_type_type next_4_right_lane_type;

   typedef double _next_4_right_c1_type;
  _next_4_right_c1_type next_4_right_c1;





  typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> const> ConstPtr;

}; // struct ld_mobileye_lane_

typedef ::ld_msgs::ld_mobileye_lane_<std::allocator<void> > ld_mobileye_lane;

typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_lane > ld_mobileye_lanePtr;
typedef boost::shared_ptr< ::ld_msgs::ld_mobileye_lane const> ld_mobileye_laneConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/xiaotongliu/CANMessageParser/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2576f5708d76bd715056b35997fa9bfc";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_lane_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2576f5708d76bd71ULL;
  static const uint64_t static_value2 = 0x5056b35997fa9bfcULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_mobileye_lane";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_lane_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
# not the file protocol_extlogdata2_2.25\n\
\n\
Header header\n\
string type\n\
\n\
#see \"AM_Ext protocol.pdf\"\n\
\n\
#0x669\n\
\n\
float64 distance_to_left_lane\n\
float64 distance_to_right_lane\n\
\n\
#0x76b:number of next lane markers reported\n\
#Header header_number_of_next_lane\n\
uint8 number_of_next_lane\n\
\n\
#0x76c & 0x76d + 4n (n=0..3) will be for the left lane.\n\
#0x76e & 0x76f + 4n (n=0..3) will be for the right lane.\n\
#remark: currently two lane marks are always reported one for left and one for\n\
#right, and they are valid only if the lane type is solid.\n\
\n\
\n\
# see \"LKA common CAN protocol.pdf\"\n\
string address\n\
uint8 ID\n\
#0x766\n\
#Header left_header_A\n\
float64 left_c0 #bitcode ist signed 16bits\n\
float64 left_c2\n\
float64 left_c3\n\
float64 left_width_marking\n\
uint8 left_model_degree\n\
uint8 left_quality\n\
uint8 left_lane_type\n\
\n\
#0x767\n\
#Header left_header_B\n\
float64 left_c1\n\
\n\
#0x768\n\
#Header right_header_A\n\
float64 right_c0\n\
float64 right_c2\n\
float64 right_c3\n\
float64 right_width_marking\n\
uint8 right_model_degree\n\
uint8 right_quality\n\
uint8 right_lane_type\n\
\n\
#0x769\n\
#Header right_header_B\n\
float64 right_c1\n\
\n\
\n\
\n\
#0x76c\n\
#Header next_1_left_header_A\n\
float64 next_1_left_c0 \n\
float64 next_1_left_c2\n\
float64 next_1_left_c3\n\
float64 next_1_left_width_marking\n\
uint8 next_1_left_model_degree\n\
uint8 next_1_left_quality\n\
uint8 next_1_left_lane_type\n\
\n\
#0x76d\n\
#Header next_1_left_header_B\n\
float64 next_1_left_c1\n\
\n\
#0x76e\n\
#Header next_1_right_header_A\n\
float64 next_1_right_c0\n\
float64 next_1_right_c2\n\
float64 next_1_right_c3\n\
float64 next_1_right_width_marking\n\
uint8 next_1_right_model_degree\n\
uint8 next_1_right_quality\n\
uint8 next_1_right_lane_type\n\
\n\
#0x76f\n\
#Header next_1_right_header_B\n\
float64 next_1_right_c1\n\
\n\
#0x770\n\
#Header next_2_left_header_A\n\
float64 next_2_left_c0 \n\
float64 next_2_left_c2\n\
float64 next_2_left_c3\n\
float64 next_2_left_width_marking\n\
uint8 next_2_left_model_degree\n\
uint8 next_2_left_quality\n\
uint8 next_2_left_lane_type\n\
\n\
#0x771\n\
#Header next_2_left_header_B\n\
float64 next_2_left_c1\n\
\n\
#0x772\n\
#Header next_2_right_header_A\n\
float64 next_2_right_c0\n\
float64 next_2_right_c2\n\
float64 next_2_right_c3\n\
float64 next_2_right_width_marking\n\
uint8 next_2_right_model_degree\n\
uint8 next_2_right_quality\n\
uint8 next_2_right_lane_type\n\
\n\
#0x773\n\
#Header next_2_right_header_B\n\
float64 next_2_right_c1\n\
\n\
#0x774-next-3-left\n\
#Header next_3_left_header_A\n\
float64 next_3_left_c0 \n\
float64 next_3_left_c2\n\
float64 next_3_left_c3\n\
float64 next_3_left_width_marking\n\
uint8 next_3_left_model_degree\n\
uint8 next_3_left_quality\n\
uint8 next_3_left_lane_type\n\
\n\
#0x775-next-3-left\n\
#Header next_3_left_header_B\n\
float64 next_3_left_c1\n\
\n\
#0x776-next-3-right\n\
#Header next_3_right_header_A\n\
float64 next_3_right_c0\n\
float64 next_3_right_c2\n\
float64 next_3_right_c3\n\
float64 next_3_right_width_marking\n\
uint8 next_3_right_model_degree\n\
uint8 next_3_right_quality\n\
uint8 next_3_right_lane_type\n\
\n\
#0x777-next-3-right\n\
#Header next_3_right_header_B\n\
float64 next_3_right_c1\n\
\n\
\n\
#0x778-next-4-left\n\
#Header next_4_left_header_A\n\
float64 next_4_left_c0 \n\
float64 next_4_left_c2\n\
float64 next_4_left_c3\n\
float64 next_4_left_width_marking\n\
uint8 next_4_left_model_degree\n\
uint8 next_4_left_quality\n\
uint8 next_4_left_lane_type\n\
\n\
#0x779-next-4-left\n\
#Header next_4_left_header_B\n\
float64 next_4_left_c1\n\
\n\
#0x77a-next-4-right\n\
#Header next_4_right_header_A\n\
float64 next_4_right_c0\n\
float64 next_4_right_c2\n\
float64 next_4_right_c3\n\
float64 next_4_right_width_marking\n\
uint8 next_4_right_model_degree\n\
uint8 next_4_right_quality\n\
uint8 next_4_right_lane_type\n\
\n\
#0x77b-next-4-right\n\
#Header next_4_right_header_B\n\
float64 next_4_right_c1\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::ld_msgs::ld_mobileye_lane_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.type);
      stream.next(m.distance_to_left_lane);
      stream.next(m.distance_to_right_lane);
      stream.next(m.number_of_next_lane);
      stream.next(m.address);
      stream.next(m.ID);
      stream.next(m.left_c0);
      stream.next(m.left_c2);
      stream.next(m.left_c3);
      stream.next(m.left_width_marking);
      stream.next(m.left_model_degree);
      stream.next(m.left_quality);
      stream.next(m.left_lane_type);
      stream.next(m.left_c1);
      stream.next(m.right_c0);
      stream.next(m.right_c2);
      stream.next(m.right_c3);
      stream.next(m.right_width_marking);
      stream.next(m.right_model_degree);
      stream.next(m.right_quality);
      stream.next(m.right_lane_type);
      stream.next(m.right_c1);
      stream.next(m.next_1_left_c0);
      stream.next(m.next_1_left_c2);
      stream.next(m.next_1_left_c3);
      stream.next(m.next_1_left_width_marking);
      stream.next(m.next_1_left_model_degree);
      stream.next(m.next_1_left_quality);
      stream.next(m.next_1_left_lane_type);
      stream.next(m.next_1_left_c1);
      stream.next(m.next_1_right_c0);
      stream.next(m.next_1_right_c2);
      stream.next(m.next_1_right_c3);
      stream.next(m.next_1_right_width_marking);
      stream.next(m.next_1_right_model_degree);
      stream.next(m.next_1_right_quality);
      stream.next(m.next_1_right_lane_type);
      stream.next(m.next_1_right_c1);
      stream.next(m.next_2_left_c0);
      stream.next(m.next_2_left_c2);
      stream.next(m.next_2_left_c3);
      stream.next(m.next_2_left_width_marking);
      stream.next(m.next_2_left_model_degree);
      stream.next(m.next_2_left_quality);
      stream.next(m.next_2_left_lane_type);
      stream.next(m.next_2_left_c1);
      stream.next(m.next_2_right_c0);
      stream.next(m.next_2_right_c2);
      stream.next(m.next_2_right_c3);
      stream.next(m.next_2_right_width_marking);
      stream.next(m.next_2_right_model_degree);
      stream.next(m.next_2_right_quality);
      stream.next(m.next_2_right_lane_type);
      stream.next(m.next_2_right_c1);
      stream.next(m.next_3_left_c0);
      stream.next(m.next_3_left_c2);
      stream.next(m.next_3_left_c3);
      stream.next(m.next_3_left_width_marking);
      stream.next(m.next_3_left_model_degree);
      stream.next(m.next_3_left_quality);
      stream.next(m.next_3_left_lane_type);
      stream.next(m.next_3_left_c1);
      stream.next(m.next_3_right_c0);
      stream.next(m.next_3_right_c2);
      stream.next(m.next_3_right_c3);
      stream.next(m.next_3_right_width_marking);
      stream.next(m.next_3_right_model_degree);
      stream.next(m.next_3_right_quality);
      stream.next(m.next_3_right_lane_type);
      stream.next(m.next_3_right_c1);
      stream.next(m.next_4_left_c0);
      stream.next(m.next_4_left_c2);
      stream.next(m.next_4_left_c3);
      stream.next(m.next_4_left_width_marking);
      stream.next(m.next_4_left_model_degree);
      stream.next(m.next_4_left_quality);
      stream.next(m.next_4_left_lane_type);
      stream.next(m.next_4_left_c1);
      stream.next(m.next_4_right_c0);
      stream.next(m.next_4_right_c2);
      stream.next(m.next_4_right_c3);
      stream.next(m.next_4_right_width_marking);
      stream.next(m.next_4_right_model_degree);
      stream.next(m.next_4_right_quality);
      stream.next(m.next_4_right_lane_type);
      stream.next(m.next_4_right_c1);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_mobileye_lane_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_mobileye_lane_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_mobileye_lane_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "type: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.type);
    s << indent << "distance_to_left_lane: ";
    Printer<double>::stream(s, indent + "  ", v.distance_to_left_lane);
    s << indent << "distance_to_right_lane: ";
    Printer<double>::stream(s, indent + "  ", v.distance_to_right_lane);
    s << indent << "number_of_next_lane: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.number_of_next_lane);
    s << indent << "address: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.address);
    s << indent << "ID: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.ID);
    s << indent << "left_c0: ";
    Printer<double>::stream(s, indent + "  ", v.left_c0);
    s << indent << "left_c2: ";
    Printer<double>::stream(s, indent + "  ", v.left_c2);
    s << indent << "left_c3: ";
    Printer<double>::stream(s, indent + "  ", v.left_c3);
    s << indent << "left_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.left_width_marking);
    s << indent << "left_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_model_degree);
    s << indent << "left_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_quality);
    s << indent << "left_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_lane_type);
    s << indent << "left_c1: ";
    Printer<double>::stream(s, indent + "  ", v.left_c1);
    s << indent << "right_c0: ";
    Printer<double>::stream(s, indent + "  ", v.right_c0);
    s << indent << "right_c2: ";
    Printer<double>::stream(s, indent + "  ", v.right_c2);
    s << indent << "right_c3: ";
    Printer<double>::stream(s, indent + "  ", v.right_c3);
    s << indent << "right_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.right_width_marking);
    s << indent << "right_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_model_degree);
    s << indent << "right_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_quality);
    s << indent << "right_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_lane_type);
    s << indent << "right_c1: ";
    Printer<double>::stream(s, indent + "  ", v.right_c1);
    s << indent << "next_1_left_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_left_c0);
    s << indent << "next_1_left_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_left_c2);
    s << indent << "next_1_left_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_left_c3);
    s << indent << "next_1_left_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_left_width_marking);
    s << indent << "next_1_left_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_left_model_degree);
    s << indent << "next_1_left_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_left_quality);
    s << indent << "next_1_left_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_left_lane_type);
    s << indent << "next_1_left_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_left_c1);
    s << indent << "next_1_right_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_right_c0);
    s << indent << "next_1_right_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_right_c2);
    s << indent << "next_1_right_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_right_c3);
    s << indent << "next_1_right_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_right_width_marking);
    s << indent << "next_1_right_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_right_model_degree);
    s << indent << "next_1_right_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_right_quality);
    s << indent << "next_1_right_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_1_right_lane_type);
    s << indent << "next_1_right_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_1_right_c1);
    s << indent << "next_2_left_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_left_c0);
    s << indent << "next_2_left_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_left_c2);
    s << indent << "next_2_left_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_left_c3);
    s << indent << "next_2_left_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_left_width_marking);
    s << indent << "next_2_left_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_left_model_degree);
    s << indent << "next_2_left_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_left_quality);
    s << indent << "next_2_left_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_left_lane_type);
    s << indent << "next_2_left_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_left_c1);
    s << indent << "next_2_right_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_right_c0);
    s << indent << "next_2_right_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_right_c2);
    s << indent << "next_2_right_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_right_c3);
    s << indent << "next_2_right_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_right_width_marking);
    s << indent << "next_2_right_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_right_model_degree);
    s << indent << "next_2_right_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_right_quality);
    s << indent << "next_2_right_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_2_right_lane_type);
    s << indent << "next_2_right_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_2_right_c1);
    s << indent << "next_3_left_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_left_c0);
    s << indent << "next_3_left_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_left_c2);
    s << indent << "next_3_left_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_left_c3);
    s << indent << "next_3_left_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_left_width_marking);
    s << indent << "next_3_left_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_left_model_degree);
    s << indent << "next_3_left_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_left_quality);
    s << indent << "next_3_left_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_left_lane_type);
    s << indent << "next_3_left_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_left_c1);
    s << indent << "next_3_right_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_right_c0);
    s << indent << "next_3_right_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_right_c2);
    s << indent << "next_3_right_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_right_c3);
    s << indent << "next_3_right_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_right_width_marking);
    s << indent << "next_3_right_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_right_model_degree);
    s << indent << "next_3_right_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_right_quality);
    s << indent << "next_3_right_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_3_right_lane_type);
    s << indent << "next_3_right_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_3_right_c1);
    s << indent << "next_4_left_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_left_c0);
    s << indent << "next_4_left_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_left_c2);
    s << indent << "next_4_left_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_left_c3);
    s << indent << "next_4_left_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_left_width_marking);
    s << indent << "next_4_left_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_left_model_degree);
    s << indent << "next_4_left_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_left_quality);
    s << indent << "next_4_left_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_left_lane_type);
    s << indent << "next_4_left_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_left_c1);
    s << indent << "next_4_right_c0: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_right_c0);
    s << indent << "next_4_right_c2: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_right_c2);
    s << indent << "next_4_right_c3: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_right_c3);
    s << indent << "next_4_right_width_marking: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_right_width_marking);
    s << indent << "next_4_right_model_degree: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_right_model_degree);
    s << indent << "next_4_right_quality: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_right_quality);
    s << indent << "next_4_right_lane_type: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.next_4_right_lane_type);
    s << indent << "next_4_right_c1: ";
    Printer<double>::stream(s, indent + "  ", v.next_4_right_c1);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_MOBILEYE_LANE_H
